<?php
	abstract class __exchange_auto {
		protected static $importDirectory = "./sys-temp/1c_import/";
		
		protected function saveIncomingFile() {
			$file_name = getRequest('filename');
			$buffer = outputBuffer::current('HTTPOutputBuffer');
			$content = $buffer->getHTTPRequestBody();

			if (!strlen($file_name)) return "failure\nEmpty filename.";
			list($dir_name, , $extension) = array_values(getPathInfo($file_name));
			if (!strlen($extension) || !umiFile::isAllowedFileType($extension)) return "failure\nUnknown file type.";

			if (!isset($_SESSION['1c_latest_catalog-file'])) {
				$_SESSION['1c_latest_catalog-file'] = "";
			}
			$i_flag = ($_SESSION['1c_latest_catalog-file'] == $file_name ? FILE_APPEND : 0);

			$base_name = substr($file_name, 0, strlen($file_name) - strlen($extension) - 1);

			$temp_dir = self::$importDirectory;
			if (!is_dir($temp_dir)) mkdir($temp_dir, 0777, true);

            switch(strtolower($extension)){
                case "zip":
                case "xml":
                    file_put_contents($temp_dir . $base_name . "." . $extension, $content, $i_flag);
                    break;
                default:
                    $quota_byte = getBytesFromString( mainConfiguration::getInstance()->get('system', 'quota-files-and-images') );

                    if ( $quota_byte != 0 ) {
                        $all_size = getBusyDiskSize();
                        if( ($all_size + strlen($content)) >= $quota_byte ) {
                            return "failure\nReached maximum allowed size for /files and /images directories.";
                        }
                    }

                    $images_dir = "./images/cms/data/" . $dir_name . "/";
                    if (!is_dir($images_dir)) mkdir($images_dir, 0777, true);
                    file_put_contents("./images/cms/data/" . $file_name, $content, $i_flag);

                    if (realpath("./images/cms/data/" . $file_name) != CURRENT_WORKING_DIR . "/images/cms/data/" . $file_name) {
                        unlink("./images/cms/data/" . $file_name);
                        return "failure\nWrong file path.";
                    }
                    break;
            }

			$_SESSION['1c_latest_catalog-file'] = $file_name;

			return "success";
		}

		protected function importCommerceML() {

            /*----CUSTOM-----*/
            if(class_exists("ZipArchive")) {
                $filesZip = glob(self::$importDirectory . "*.zip");
                if (!empty($filesZip)) {
                    #file_put_contents(CURRENT_WORKING_DIR . "/test1c.txt", "\r\n" . $filesZip[0] . "\r\n", FILE_APPEND);

                    $zip = new ZipArchive();
                    if ($zip->open($filesZip[0]) === true) {
                        $zip->extractTo(self::$importDirectory); //Извлекаем файлы в указанную директорию
                        $zip->close(); //Завершаем работу с архивом
                    } else return "failure\nNo zip file.";//Выводим уведомление об ошибке

                    if (is_dir(self::$importDirectory . "/import_files")) {
                        exec("mv " . self::$importDirectory . "/import_files " . CURRENT_WORKING_DIR . "/images/cms/data");
                        removeDirectory(self::$importDirectory . "/import_files");
                    }

                    unlink($filesZip[0]);
                }
            }
            /*----CUSTOM----*/

			$file_name = getRequest('filename');
			$file_path = self::$importDirectory . $file_name;

			if (!is_file($file_path)) return "failure\nFile $file_path does not exist.";
			$import_offset = (int) getSession("1c_import_offset");

			$blockSize = (int) mainConfiguration::getInstance()->get("modules", "exchange.splitter.limit");
			if($blockSize < 0) $blockSize = 25;

			$splitterName = (string) mainConfiguration::getInstance()->get("modules", "exchange.commerceML.splitter");
			if(!trim(strlen($splitterName))) $splitterName = "commerceML2";

			$splitter = umiImportSplitter::get($splitterName);
			$splitter->load($file_path, $blockSize, $import_offset);
			$doc = $splitter->getDocument();
			$xml = $splitter->translate($doc);

			$oldIgnoreSiteMap =  umiHierarchy::$ignoreSiteMap;
			umiHierarchy::$ignoreSiteMap = true;

			$importer = new xmlImporter();
			$importer->loadXmlString($xml);
			$importer->setIgnoreParentGroups($splitter->ignoreParentGroups);
			$importer->setAutoGuideCreation($splitter->autoGuideCreation);
			$importer->setRenameFiles($splitter->getRenameFiles());
			$importer->execute();

			umiHierarchy::$ignoreSiteMap = $oldIgnoreSiteMap;

			$_SESSION['1c_import_offset'] = $splitter->getOffset();

			if ($splitter->getIsComplete()) {
				$importFinished = new umiEventPoint('exchangeOnAutoFinish');
				$importFinished->setMode('after');
				$importFinished->addRef('splitter', $splitter);
				$importFinished->call();
			}

			if ($splitter->getIsComplete()) {
				$_SESSION['1c_import_offset'] = 0;
				return "success\nComplete. Imported elements: " . $splitter->getOffset();
			}

			return "progress\nImported elements: " . $splitter->getOffset();
		}

		protected function exportOrders() {
			$exporter = umiExporter::get("ordersCommerceML");
			$exporter->setOutputBuffer();
			$result = $exporter->export(array(), array());
			return $result;
		}

		protected function markExportedOrders() {
			$sel = new selector('objects');
			$sel->types('hierarchy-type')->name('emarket', 'order');
			$sel->where('need_export')->equals(1);
			$orders = $sel->result;
			foreach ($orders as $order) {
				$order->need_export = 0;
			}

			return "success";
		}

		protected function importOrders() {
			self::saveIncomingFile();
			$file_name = getRequest('filename');
			$file_path = self::$importDirectory . $file_name;

			if (!is_file($file_path)) return "failure\nFile $file_path does not exist.";

			$splitterName = (string) mainConfiguration::getInstance()->get("modules", "exchange.commerceML.splitter");
			if(!trim(strlen($splitterName))) $splitterName = "commerceML2";

			$splitter = umiImportSplitter::get($splitterName);
			$splitter->load($file_path);
			$doc = $splitter->getDocument();
			$xml = $splitter->translate($doc);

			$importer = new xmlImporter();
			$importer->loadXmlString($xml);
			$importer->setIgnoreParentGroups($splitter->ignoreParentGroups);
			$importer->setAutoGuideCreation($splitter->autoGuideCreation);
			$importer->execute();


			return "success";
		}


		public function auto() {

			$timeOut = (int) mainConfiguration::getInstance()->get("modules", "exchange.commerceML.timeout");
			if ($timeOut < 0) $timeOut = 0;

			sleep($timeOut);

			$buffer = outputBuffer::current('HTTPOutputBuffer');
			$buffer->charset('utf-8');
			$buffer->contentType('text/plain');

			$type = getRequest("type");
			$mode = getRequest("mode");
			$instance1c = getRequest('param0') ? md5(getRequest('param0')) . "/" : '';
			self::$importDirectory = "./sys-temp/1c_import/" . $instance1c;

			if (!permissionsCollection::getInstance()->isSv()) {
				$buffer->push("failure\nNot authorized as supervisor.");
				$buffer->end();
				exit();
			}

			switch($type . "-" . $mode) {
				case "catalog-checkauth":
					// clear temp
					removeDirectory(self::$importDirectory);
				case "sale-checkauth": {
					$buffer->push("success\nPHPSESSID\n" . session_id());
				} break;
				case "catalog-init":
				case "sale-init": {
					removeDirectory(self::$importDirectory);
					$maxFileSize = (int) mainConfiguration::getInstance()->get("modules", "exchange.commerceML.maxFileSize");
					if ($maxFileSize <= 0) $maxFileSize = 102400;
					$buffer->push("zip=".(class_exists("ZipArchive")?"yes":"no")."\nfile_limit={$maxFileSize}");
				} break;
				case "catalog-file": {
					$buffer->push(self::saveIncomingFile());
				} break;
				case "catalog-import" : {
					$buffer->push(self::importCommerceML());
				} break;

				case "sale-query" : {
					$buffer->push(self::exportOrders());
				} break;

				case "sale-success" : {
					$buffer->push(self::markExportedOrders());
				} break;

				case "sale-file" : {
					$buffer->push(self::importOrders());
				} break;

				default:
					$buffer->push("failure\nUnknown import type ($type) or mode ($mode).");
			}

			$buffer->end();
		}

	}

?>